Package fr.gouv.vitam.worker.core.plugin

# Class GenericReportGenerationHandler

java.lang.Object
fr.gouv.vitam.worker.core.handler.ActionHandler
fr.gouv.vitam.worker.core.plugin.GenericReportGenerationHandler

All Implemented Interfaces:
  `VitamAutoCloseable`, `AutoCloseable`

Direct Known Subclasses:
  `EliminationActionReportGenerationHandler`, `TransferReplyReportGenerationHandler`

public abstract class GenericReportGenerationHandler extends ActionHandler
Generate the report :
- compute data from batch-report
- store the report file
- clean the batch-report data

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `GenericReportGenerationHandler(CommonReportService<?> reportService)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ItemStatus`
  `execute(WorkerParameters param, HandlerIO handler)`
  Execute an action
  `protected Report`
  `generateReport(WorkerParameters param, LogbookOperation logbook)`
  `protected abstract String`
  `getLogbookActionKey()`
  `protected abstract LogbookOperation`
  `getLogbookInformation(HandlerIO handlerIO, WorkerParameters param)`
  `protected OperationSummary`
  `getOperationSummary(LogbookOperation logbook, String processId)`
  `protected abstract String`
  `getPluginId()`
  `protected ReportSummary`
  `getReport(LogbookOperation logbook)`
  `protected abstract ReportType`
  `getReportType()`
  `protected Map<StatusCode,Integer>`
  `getStatusStatistic(LogbookEvent logbookEvent)`

  ### Methods inherited from class fr.gouv.vitam.worker.core.handler.ActionHandler

  `checkMandatoryIOParameter, checkMandatoryParameters, close, executeList, updateDetailItemStatus`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### GenericReportGenerationHandler

    protected GenericReportGenerationHandler(CommonReportService<?> reportService)

- ## Method Details

  - ### execute

    public ItemStatus execute(WorkerParameters param, HandlerIO handler) throws ProcessingException
    Description copied from class: `ActionHandler`
    Execute an action
    Overrides:
      `execute` in class `ActionHandler`
    Parameters:
      `param` - `WorkerParameters`
      `handler` - the handlerIo
    Returns:
      CompositeItemStatus:response contains a list of functional message and status code
    Throws:
      `ProcessingException` - if an error is encountered when executing the action

  - ### getOperationSummary

    protected OperationSummary getOperationSummary(LogbookOperation logbook, String processId) throws InvalidParseOperationException
    Throws:
      `InvalidParseOperationException`

  - ### generateReport

    protected Report generateReport(WorkerParameters param, LogbookOperation logbook) throws InvalidParseOperationException
    Throws:
      `InvalidParseOperationException`

  - ### getReport

    protected ReportSummary getReport(LogbookOperation logbook)

  - ### getStatusStatistic

    protected Map<StatusCode,Integer> getStatusStatistic(LogbookEvent logbookEvent)

  - ### getPluginId

    protected abstract String getPluginId()

  - ### getReportType

    protected abstract ReportType getReportType()

  - ### getLogbookActionKey

    protected abstract String getLogbookActionKey()

  - ### getLogbookInformation

    protected abstract LogbookOperation getLogbookInformation(HandlerIO handlerIO, WorkerParameters param) throws ProcessingException
    Throws:
      `ProcessingException`